unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, DB, ADODB, StdCtrls, Mask, DBCtrls, ExtCtrls, Grids,
  DBGrids, Buttons, QuickRpt, ToolWin, Handles, QRCtrls;

type
  TFormWRC = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ADOConnection1: TADOConnection;
    ADOQueryProj: TADOQuery;
    ADOQueryProjproj_no: TWideStringField;
    ADOQueryProjproj_name: TWideStringField;
    ADOQueryProjproj_alias: TWideStringField;
    DBGrid1: TDBGrid;
    DataSourceProj: TDataSource;
    Panel1: TPanel;
    Panel2: TPanel;
    DBNavigator1: TDBNavigator;
    Panel3: TPanel;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    ADOConnection2: TADOConnection;
    ADOQueryproj_dataset: TADOQuery;
    ADOQueryproj_datasetproj_no: TWideStringField;
    ADOQueryproj_datasetdataset_class: TIntegerField;
    DBGrid2: TDBGrid;
    ADOQueryproj_datasetdataset_name: TWideStringField;
    Panel4: TPanel;
    Panel5: TPanel;
    DBNavigator2: TDBNavigator;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    ADOQueryproj_datasetdataset_sql: TMemoField;
    Label6: TLabel;
    DBMemo1: TDBMemo;
    TabSheet3: TTabSheet;
    Panel6: TPanel;
    Panel7: TPanel;
    ScrollBox1: TScrollBox;
    QuickRep1: TQuickRep;
    Panel8: TPanel;
    ToolBar1: TToolBar;
    DataSourceproj_dataset: TDataSource;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton0: TSpeedButton;
    StretchHandle1: TStretchHandle;
    Panel9: TPanel;
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    ToolBar2: TToolBar;
    SpeedButtonLoad: TSpeedButton;
    SpeedButtonSave: TSpeedButton;
    ADOQueryProjproj_report: TMemoField;
    Label7: TLabel;
    DBMemo2: TDBMemo;
    SpeedButtonClear: TSpeedButton;
    procedure ObjectMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure onquickrepmousedown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label3Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ADOQueryproj_datasetBeforePost(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    function ComponentToString(Component: TComponent): string;
    function StringToComponent(Value: string;parent:Tcomponent): TComponent;
    procedure SpeedButtonSaveClick(Sender: TObject);
    procedure SpeedButtonLoadClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButtonClearClick(Sender: TObject);
    procedure StretchHandle1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Private declarations }
  public
    { Public declarations }
    idx:integer;
  end;

var
  FormWRC: TFormWRC;
  vnull:Olevariant;

implementation

uses ADOConEd;

{$R *.dfm}
procedure TFormWRC.ObjectMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (GetKeyState(VK_SHIFT) >= 0) then
  begin
      StretchHandle1.Detach;
      StretchHandle1.Locked := False;
  end;
  if (idx=0) or not ((Sender is TQRBand) or (Sender is TQRSubdetail) or
     (Sender is TQRGroup) or (Sender is TQRSTringsBand) ) then
     StretchHandle1.Attach(TButton(sender))
  else
     onquickrepmousedown(Sender,Button,Shift, X, Y);

end;

function TFormWRC.ComponentToString(Component: TComponent): string;
var
  BinStream:TMemoryStream;
  StrStream: TStringStream;
  s: string;
begin
  BinStream := TMemoryStream.Create;
  try
    StrStream := TStringStream.Create(s);
    try
      BinStream.WriteComponent(Component);
      BinStream.Seek(0, soFromBeginning);
      ObjectBinaryToText(BinStream, StrStream);
      StrStream.Seek(0, soFromBeginning);
      Result:= StrStream.DataString;
    finally
      StrStream.Free;

    end;
  finally
    BinStream.Free
  end;
end;

function TFormWRC.StringToComponent(Value: string;parent:Tcomponent): TComponent;
var
  StrStream:TStringStream;
  BinStream: TMemoryStream;
begin
  StrStream := TStringStream.Create(Value);
  try
    BinStream := TMemoryStream.Create;
    try
      ObjectTextToBinary(StrStream, BinStream);
      BinStream.Seek(0, soFromBeginning);
      Result := BinStream.ReadComponent(parent);

    finally
      BinStream.Free;
    end;
  finally
    StrStream.Free;
  end;
end;

procedure TFormWRC.Label3Click(Sender: TObject);
begin
   ADOConnection2.Connected:=false;
   ADOConnection2.ConnectionString:=ADOQueryProj.fieldbyname('proj_alias').AsString;
   if EditConnectionString(ADOConnection2) then
   begin
      if not(ADOQueryProj.State in [dsedit,dsinsert]) then
         ADOQueryProj.Edit;
      ADOQueryProj.fieldbyname('proj_alias').AsString:=ADOConnection2.ConnectionString;
   end;
end;

procedure TFormWRC.PageControl1Change(Sender: TObject);
var ADOQ:TADOQuery;
    MyTreeNode1,MyTreeNode2:TTreeNode;
    i:integer;
begin
   case PageControl1.ActivePageIndex of
      0:begin
        end;
      1:begin
           ADOConnection2.Connected:=false;
           if (ADOQueryProj.State in [dsedit,dsinsert]) then
              ADOQueryProj.post;
           ADOConnection2.ConnectionString:=ADOQueryProj.fieldbyname('proj_alias').AsString;
           try
              ADOConnection2.Connected:=true;
           except
              showmessage('Ʈw|~');
              PageControl1.ActivePageIndex:=0;
           end;
        end;
      2:begin
           if (ADOQueryproj_dataset.State in [dsedit,dsinsert]) then
              ADOQueryproj_dataset.post;
           if not ADOConnection2.Connected then
           begin
              ADOConnection2.ConnectionString:=ADOQueryProj.fieldbyname('proj_alias').AsString;
              try
                 ADOConnection2.Connected:=true;
              except
                 showmessage('Ʈw|~');
                 PageControl1.ActivePageIndex:=0;
              end;
           end;
           if (TreeView1.Items.Count=0) or (MessageDlg('wgƦsb,O_s',mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
           begin
              TreeView1.Items.Clear;
              ADOQ:=TADOQuery.Create(self);
              ADOQ.Connection:=ADOConnection2;
              ADOQueryproj_dataset.First;
              while not ADOQueryproj_dataset.Eof do
              begin
                 ADOQ.Active:=false;
                 ADOQ.SQL.Text:=ADOQueryproj_dataset.fieldbyname('dataset_sql').AsString;
                 ADOQ.Active:=True;
                 MyTreeNode1 := TreeView1.Items.Add(nil,ADOQueryproj_dataset.fieldbyname('dataset_name').AsString);
                 for i:=0 to ADOQ.FieldCount-1 do
                 begin
                    MyTreeNode2:=TreeView1.Items.AddChild(MyTreeNode1,ADOQ.Fields[i].FieldName);
                    TreeView1.Items.AddChild(MyTreeNode2,'DisplayName:'+ADOQ.Fields[i].displayname);
                    TreeView1.Items.AddChild(MyTreeNode2,'Size:'+inttostr(ADOQ.Fields[i].Size));
                 end;
                 ADOQueryproj_dataset.Next;
              end;
              freeandnil(adoq);
           end;
           if (Quickrep1.ComponentCount=0) or (MessageDlg('ewgƦsb,O_s',mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
           begin
              SpeedButton0.Down:=True;
              idx:=0;
              SpeedButtonLoadClick(nil);
           end;
        end;
   end;
end;

procedure TFormWRC.ADOQueryproj_datasetBeforePost(DataSet: TDataSet);
begin
   ADOQueryproj_dataset.FieldByName('proj_no').AsString:=ADOQueryProj.fieldbyname('proj_no').AsString;
end;

procedure TFormWRC.onquickrepmousedown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var i,j:integer;
    s,s1:string;
    obj:Tobject;
    ab:boolean;
begin
   if idx>0 then
   begin
      case idx of
         1:S1:='QRsubdetail';
         2:s1:='QRStringsBand';
         3:s1:='QRBand';
         4:s1:='QRGroup';
         5:s1:='QRLabel';
         6:s1:='QRDBText';
         7:s1:='QRExpr';
         8:s1:='QRSysData';
         9:s1:='QRMemo';
         10:s1:='QRRichText';
         11:s1:='QRDBrichtext';
         12:s1:='QRSHAPE';
         13:s1:='QRIMAGE';
         14:s1:='QRDBImage';
      end;
      with TWincontrol(Quickrep1) do
      begin
         j:=0;
         i:=0;
         while (i<componentcount) do
         begin
            j:=j+1;
            s:=uppercase(s1+inttostr(j));
            for i:=0 to ComponentCount-1 do
            begin
               if (uppercase(TControl(Components[i]).Name)=s) then
                 break;
            end;
         end;
      end;
      case idx of
         1:obj:=TQRsubdetail.Create(TComponent(Quickrep1));
         2:obj:=TQRStringsBand.Create(TComponent(Quickrep1));
         3:obj:=TQRBand.Create(TComponent(Quickrep1));
         4:obj:=TQRGroup.Create(TComponent(Quickrep1));
         5:obj:=TQRLabel.Create(TComponent(Quickrep1));
         6:obj:=TQRDBText.Create(TComponent(Quickrep1));
         7:obj:=TQRExpr.Create(TComponent(Quickrep1));
         8:obj:=TQRSysData.Create(TComponent(Quickrep1));
         9:obj:=TQRMemo.Create(TComponent(Quickrep1));
         10:obj:=TQRRichText.Create(TComponent(Quickrep1));
         11:obj:=TQRDBrichtext.Create(TComponent(Quickrep1));
         12:obj:=TQRSHAPE.Create(TComponent(Quickrep1));
         13:obj:=TQRIMAGE.Create(TComponent(Quickrep1));
         14:obj:=TQRDBImage.Create(TComponent(Quickrep1));
      end;
      With Tbutton(obj) do
      begin
         name:=s;
         if idx in [1,2,3,4] then
         begin
            parent:=Quickrep1;
            Height:=24;
         end else
         begin
            parent:=TWinControl(Sender);
            Left:=x;
            Top:=y;
//            Height:=24;
//            Width:=20;
         end;
         OnMouseDown:=ObjectMouseDown;
      end;
   end else
   begin
      StretchHandle1.Detach;
      StretchHandle1.Locked := False;
   end;
end;

procedure TFormWRC.FormCreate(Sender: TObject);
begin
   RegisterClasses([TQRsubdetail,TQRStringsBand,TQRBand,TQRGroup,TQRLabel,
         TQRDBText,TQRExpr,TQRSysData,TQRMemo,TQRRichText,
         TQRDBrichtext,TQRSHAPE,TQRIMAGE,TQRDBImage]);
   TButton(Quickrep1).OnMouseDown:=onquickrepmousedown;
end;

procedure TFormWRC.SpeedButtonSaveClick(Sender: TObject);
begin
   if not (ADOQueryProj.State in [dsedit,dsinsert]) then
      ADOQueryProj.Edit;
   ADOQueryProj.FieldByName('proj_report').AsString:=ComponentToString(Quickrep1);
   ADOQueryProj.Post;
end;

procedure TFormWRC.SpeedButtonLoadClick(Sender: TObject);
var i:integer;
begin
   with Quickrep1 do
   begin
      while (ComponentCount>0) do
      begin
         Components[0].Free;
      end;
   end;
   StringToComponent(ADOQueryProj.FieldByName('proj_report').AsString,Quickrep1);
   with Quickrep1 do
   begin
      i:=0;
      while (i<ComponentCount) do
      begin
         TButton(Components[i]).OnMouseDown:=ObjectMouseDown;
         i:=i+1;
      end;
   end;
end;

procedure TFormWRC.SpeedButton1Click(Sender: TObject);
begin
   if TSpeedButton(sender).Down then
      idx:=TSpeedButton(sender).Tag
   else
   begin
      SpeedButton0.Down:=True;
      idx:=0;
   end;
   StretchHandle1.Detach;
   StretchHandle1.Locked := False;
end;

procedure TFormWRC.SpeedButtonClearClick(Sender: TObject);
begin
   with Quickrep1 do
   begin
      while (ComponentCount>0) do
      begin
         Components[0].Free;
      end;
   end;
end;

procedure TFormWRC.StretchHandle1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i:integer;
begin
   if key=vk_delete then
   begin
      for i:=0 to StretchHandle1.ChildCount-1 do
         StretchHandle1.Children[i].Free;
      StretchHandle1.Detach;
   end;
end;

end.
